#ifndef __GEOMETRYSET_H__
#define __GEOMETRYSET_H__

#include <set>

#include "refcount.h"

namespace xrt
{
	class Primitive;

	struct less: public std::binary_function< Reference< Primitive >, Reference< Primitive >, bool >
	{	// functor for operator<
		bool operator()( const Reference< Primitive >& a, const Reference< Primitive >& b ) const
		{	// apply operator< to operands
			return a.get() < b.get();
		}
	};

	typedef std::set< Reference< Primitive >, less > GeometrySet;
}

#endif //__GEOMETRYSET_H__