/* $Id: //depot/branches/rmanprod/rman-13.5/shaders/shinymetal.sl#1 $  (Pixar - RenderMan Division)  $Date: 2007/07/06 $ */
/*
** Copyright (c) 1999 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
*/
surface
shinymetal (float Ka=1, Ks=1, Kr = 1, roughness=.1;
	    string texturename = "";)
{
    normal Nf;
    vector V;
    vector D;
    color  Cr;

    Nf = faceforward(normalize(N), I) ;
    V = normalize(-I);
    D = reflect(I, Nf) ;
    D = vtransform ("world", D);

    if (texturename != "") {
	Cr = Kr * color environment(texturename, D);
    } else {
	Cr = 0.;
    }

    Oi = Os;
    Ci = Os * Cs * ( Ka*ambient() + Ks*specular(Nf,V,roughness) + Cr);
}
