light ystspherelight(
    color lightcolor = 1;
    point from = point "shader" (0, 0, 0);
    float falloff = 2;
    float radius = 1;
    float samples = 16 )
{
    uniform float anglesamples, zsamples, i, j;
    float angle, z, r, dist;
    vector l;
    color c;
    point p;
    
    /* Choose number of strata for stratification */
    anglesamples = floor(sqrt(samples));
    zsamples = floor(samples/anglesamples);

    illuminate (from) 
    {
        for (j = 0; j < zsamples; j += 1)  
        {
            for (i = 0; i < anglesamples; i += 1)  
            {
                /* Compute stratified random angle in [0,2pi] */
				angle = 2 * PI * (i + random()) / anglesamples;
				/* Compute stratified random z in [-1,1] */
                z = (j + random()) / zsamples;
                z = 2 * z - 1;
                /* Compute point p on sphere */
                r = sqrt(1 - z*z);
                p = from + radius * vector(r * cos(angle), r * sin(angle), z);
                /* Compute distance from point p to surface point Ps */
                l = p - Ps;
                dist = length(l);
                /* Compute light from point p to surface point Ps */
                c = pow(dist, -falloff);   /* distance falloff */
                c *= transmission(Ps, p);   /* ray traced occlusion */
                Cl += c;
			}
		}
        Cl *= lightcolor;
        Cl /= zsamples * anglesamples; /* can be different from 'samples' */
    }
}
