light ystspotlight(
    color lightcolor = 1;
    point from = point "shader" (0, 0, 0);
    point to =   point "shader" (0, 0, 1);
    float maxangle = radians(20);
    float minangle = radians(10);
    float falloff = 2 )
{
    float cosangle;
    uniform vector A = (to - from) / length(to - from);
    uniform float cosoutside = cos(maxangle);
    uniform float cosinside  = cos(minangle);

    illuminate (from, A, maxangle) 
    {
        cosangle = (L . A) / length(L);
        Cl = lightcolor * pow( length(L), -falloff );
		Cl *= smoothstep(cosoutside, cosinside, cosangle);
        Cl *= 1 - shadow( "raytrace", Ps );
    }
}
