/*-*-C++-*------------------------------------------------------------------
 * gaol -- Just Another Interval Library
 *--------------------------------------------------------------------------
 * This file is part of the gaol distribution. Gaol was primarily 
 * developed at the Swiss Federal Institute of Technology, Lausanne, 
 * Switzerland, and is now developed at the Institut de Recherche 
 * en Informatique de Nantes, France.
 *
 * Copyright (c) 2001 Swiss Federal Institute of Technology, Switzerland
 * Copyright (c) 2002 Institut de Recherche en Informatique de Nantes, France
 *--------------------------------------------------------------------------
 * gaol is a software distributed WITHOUT ANY WARRANTY. Read the associated 
 * COPYING file for information.
 *--------------------------------------------------------------------------
 * CVS: $Id: gaol_dtoa.h,v 1.4 2006/04/19 02:05:08 goualard Exp $
 * Last modified: Wed Apr 19 04:03:25 2006 on proust
 * By: Frdric Goualard <Frederic.Goualard@univ-nantes.fr>
 *--------------------------------------------------------------------------*/

/*!
  \file   gaol_dtoa.h
  \brief  Header for dta.c from David M. Gay

  <long description>

  \author Frederic Goualard
  \date   2002-03-22
*/


#ifndef __gaol_dtoa_h__
#define __gaol_dtoa_h__

#include "gaol/gaol_config.h"

#if defined (_MSC_VER)
# define GAOL_EXTERN extern 
#else
# define GAOL_EXTERN extern "C"
#endif 

GAOL_EXTERN _GAOL_DLL_ double gay_strtod(const char *s00, char **se);
GAOL_EXTERN _GAOL_DLL_ char *gay_dtoa(double d, int mode, int ndigits,
				     int *decpt, int *sign, char **rve);

extern _GAOL_DLL_ int Flt_Rounds;

#undef GAOL_EXTERN
#endif /* __gaol_dtoa_h__ */
